#include <stdlib.h>
#include <err.h>

void *
ensure_pointer(void *p, size_t size)
{
	if (p == NULL)
		errx(1, "Out of memory? tried to  allocate: %u", size);
	return p;
}

void *
_malloc(size_t size)
{
	return ensure_pointer(malloc(size), size);
}

void *
_calloc(size_t nmemb, size_t size)
{
	return ensure_pointer(calloc(nmemb, size), nmemb*size);
}

void *
_realloc(void *ptr, size_t size)
{
	return ensure_pointer(realloc(ptr, size), size);
}
