/*
 * Copyright (c) 2010 Eirik A. Nygaard <eirikald@pvv.ntnu.no>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * $Id: hash.h 92 2007-04-28 11:42:36Z eirik $
 */

#ifndef _HASH_H_
#define _HASH_H_

typedef unsigned int hashvalue;

struct hashtable {
	hashvalue size;
	hashvalue entries;
	struct {
		void *key;
		void *value;
	} *entry;
	hashvalue (*hf)(void *, hashvalue);
	int (*cmp)(void *, void *);
};
typedef struct hashtable *hashtable_t;

hashtable_t hash_make(hashvalue, hashvalue(*)(void *, hashvalue),
                      int(*cmp)(void *, void *));
void hash_destroy(hashtable_t);
void *hash_get(hashtable_t, void *);
int hash_insert(hashtable_t, void *, void *);
int hash_remove(hashtable_t, void *);

/* Hash functions */
hashvalue hash_hf_charp(void *, hashvalue);

int *hash_int_to_intp(int);

#endif /* _HASH_H_ */

