%{

#include "protocol.h"
#include "location.h"
#include "protocol-parser.h"


#define YY_EXTRA_TYPE protocol_parser_t * 

%}

%option reentrant
%option bison-bridge

%%

[ \t]+		{ }
update		{ return UPDATE; } 
search		{ return SEARCH; }
user		{ return USER; }
server		{ return SERVER; }
fetch		{ return FETCH; }
subscribe	{ return SUBSCRIBE; }
subscribers	{ return SUBSCRIBERS; }
poll		{ return POLL; }
newuser		{ return NEWUSER; }
\[		{ return LBRACKET; }
\]		{ return RBRACKET; }
[\-+]?[0-9]+\.[0-9]+	{
			yylval->number = strtod(yytext, NULL);
			return NUMBER;
		}
[\-+]?[0-9]+	{
			yylval->number = (double)strtol(yytext, NULL, 10);
			return NUMBER;
		}
\"[^"]+\"	{
			char *str = yytext+1;
			str[strlen(str)-1] = '\0';
			yylval->str = strdup(str);
			return STRING;
		}
N|W		{ return yytext[0]; }
.		{
			yyextra->errors++;
			printf("Unknown character: %d/'%c'\n",
			    yytext[0], yytext[0]);
		}
\n		{ printf("newline?\n"); }


%%


