#ifndef _PROTOCOL_H_
#define _PROTOCOL_H_

#include "server.h"
#include "location.h"

typedef enum {
	CMD_UPDATE_USER,
	CMD_UPDATE,
	CMD_FETCH,
	CMD_SUBSCRIBE,
	CMD_SUBSCRIBERS,
	CMD_POLL,
	CMD_NEWUSER,
} command_type_t;

typedef struct {
	command_type_t type;
	union {
		struct {
			char *user, *pass;
			location_t *loc;
		} update;
		char *user;
		struct {
			char *subscriber;
			char *user;
		} subscribe;
	} args;
} command_t;

command_t *command_new(command_type_t type);


typedef struct {
	int errors;
	char *errormsg;
	command_t *command;
} protocol_parser_t;

protocol_parser_t *protocol_parser_state_init(void);
void protocol_parser_state_destroy(protocol_parser_t *pstate);
int protocol(struct server_request *);

#endif
