#ifndef _QUEUE_H_
#define _QUEUE_H_

#include <pthread.h>

typedef int (*queue_func)(void *);

typedef struct queue_elem {
	void *obj;
	queue_func func;
	struct queue_elem *next;
} queue_elem_t;

typedef struct queue {
	queue_elem_t *head, *tail;
	size_t length;
	pthread_mutex_t lock;
	pthread_cond_t cond;
} queue_t;

queue_t *queue_new(void);
void queue_add(queue_t *q, queue_func f, void *obj);
queue_elem_t *queue_get(queue_t *q);
void queue_processer(queue_t *q, int *keep_running);

#endif
