#ifndef _SERVER_H_
#define _SERVER_H_

#include <sys/types.h>

#include <pthread.h>

#include "queue.h"

int server_id;

struct server_handler_args {
	int listen_socket;
	queue_t *queue;
};

struct server_connection {
	pthread_mutex_t *lock;
	int ref;
	int sock;
};

struct server_request {
	ssize_t n;
	char buffer[4096];
	int sock;
	struct server_connection *conn;
};

struct server_list {
	int id;

	char ip[128];
	char backup_ip[128];
};

void *server_handler(void *);
int server_listen(char *port, struct server_handler_args *args);
void server_connection_grab(struct server_connection *conn);
void server_connection_release(struct server_connection *conn);
void server_read_list(char *file);

#endif
