#ifndef _STORE_H_
#define _STORE_H_

#include <db.h>

#include "location.h"

typedef struct {
	DBC *cursor;
	size_t num;
	DBT key, data;
	char *user;
	char subscriber[4096]; // XXX
} subscriber_cursor_t;

int store_user_location(char *user, location_t *l);
int store_get_location(char *user, location_t *l);

int store_add_subscriber(char *user, char *subscriber);

subscriber_cursor_t *store_get_subscribers(char *user);
char *store_get_subscribers_next(subscriber_cursor_t *c);
void store_get_subscribers_end(subscriber_cursor_t *c);

#endif
