#include <ctype.h>
#include <pthread.h>
#include <stdio.h>
#include <err.h>
#include <stdlib.h>

#include "user.h"

/*
 * A username is on the form homeserverid-userid
 *
 * The userid is only unique on each server
 */
int
valid_user(char *user, char *pass, int *server_id, int *user_id)
{
	char *p;

	p = user;
	if (server_id)
		*server_id = atoi(p);
	for (; *p; p++) {
		if (!isdigit(*p))
			break;
	}
	if (*p != '-')
		return 0;
	p++;
	if (user_id)
		*user_id = atoi(p);
	for (; *p; p++) {
		if (!isdigit(*p))
			return 0;
	}

	return 1;
}

void
user_init(void)
{

}

pthread_mutex_t userid_file_lock = PTHREAD_MUTEX_INITIALIZER;

int
generate_userid(void)
{
	FILE *fp;
	int user;
	char buffer[128];
	size_t len;

	pthread_mutex_lock(&userid_file_lock);
	if ((fp = fopen("db/userid_counter", "r")) == NULL) {
		warn("Unable to open userid counter filer, setting user as 1");
		user = 0;
	} else {
		len = fread(buffer, 1, sizeof(buffer), fp);
		buffer[len] = '\0';
		user = atoi(buffer);
	}
	if (user > 0)
		fclose(fp);
	user++;

	if ((fp = fopen("db/userid_counter", "w")) == NULL)
		err(1, "Unable to write userid counter file");
	fprintf(fp, "%d", user);
	fclose(fp);
	pthread_mutex_unlock(&userid_file_lock);

	return user;
}
